#include <stdio.h>
#include <linux/ps2/pad.h>
#include <fcntl.h>

#define PS2PAD_ALLUP 0xFFFF
#define PS2PAD_SWITCHDIGANA 0xA0

int up(int button) {
  int i,j,k;

  switch (button) {
    case PS2PAD_BUTTON_TRIANGLE:
      printf("Triangle\n");
      break;
    case PS2PAD_BUTTON_CROSS:
      printf("X\n");
      break;
    case PS2PAD_BUTTON_SQUARE:
      printf("Square\n");
      break;
    case PS2PAD_BUTTON_CIRCLE:
      printf("Circle\n");
      break;
    case PS2PAD_BUTTON_LEFT:
      printf("Left\n");
      break;
    case PS2PAD_BUTTON_RIGHT:
      printf("Right\n");
      break;
    case PS2PAD_BUTTON_UP:
      printf("Up\n");
      break;
    case PS2PAD_BUTTON_DOWN:
      printf("Down\n");
      break;
    case PS2PAD_BUTTON_L1:
      printf("L1\n");
      break;
    case PS2PAD_BUTTON_L2:
      printf("L2\n");
      break;
    case PS2PAD_BUTTON_R1:
      printf("R1\n");
      break;
    case PS2PAD_BUTTON_R2:
      printf("R2\n");
      break;
    default:
      break;
  }
  fflush(NULL);

  return 1;
}

int check_change(int new, int old) {
  int i, check;
  for (i=0; i<16; i++) {
    check = 1 << i;
    if ((new & check) != (old & check)) {
      if (new & check) {
        up(check);
      } else {
      }
    }
  }
  return 1;
}

int main (int argc, char *argv[]) {
  int fd, i, old=PS2PAD_ALLUP;
  unsigned char buf[PS2PAD_DATASIZE];
  char *nextprint = NULL;
  int downcount=0, downcount2=0;

  fd = open("/dev/ps2pad00",O_RDONLY);
  if (fd < 0) {
    printf("Couldn't open /dev/ps2pad00\n");
    sleep(5);
    exit(1);
  }
  while (1) {
    usleep(20000);
    read(fd,buf,PS2PAD_DATASIZE);
    if (buf[0] == PS2PAD_SWITCHDIGANA) continue;
    i = (buf[2] << 8) + buf[3];
    if (i != old) {
      check_change(i,old);
      old = i;
    } else {
      old = i;
    }
    if (old != PS2PAD_ALLUP) {
      if (downcount++ > 30) {
        if (downcount++ > 20) {
          up(~old & 0xFFFF);
          downcount2 = 0;
        }
      }
    } else {
      downcount = 0;
      downcount2 = 0;
    }
  }
  close(fd);
}
